.\" This definition swiped from the gcc(1) man page
.de Sp
.if n .sp
.if t .sp 0.4
..
.TH BLASTER SCANNER 1
.SH NAME
BLASTER SCANNER [ver 3.0]
.SH SYNOPSIS
.B [Puerto-menor] [Puerto-mayor] [Opciones] <ip-host> -o 
<lista-usuarios> <lista-password>
.SH DESCRIPTION
.I BLASTER

BLASTER scanner tiene como idea tratar de que cumpla la
funcion de varios scanners en uno solo, para que no tengamos que estar
utilizando un scanner distinto para cada cosa.
    Por ahora el scanner incorpora esstas posibilidades:

  - Scanner de puertos (tcp , conexion completa)
  - Scanner SYN de puerto (half-open connection)
  - Scan Subnet
  - Ping Host to scan
  - Detecta puerto filtrados y host que estan flitrando paquetes icmp
  - Saca usuarios mediante expn (puerto 25)
  - Saca usuarios mediante vrfy (puerto 25)
  - Saca usuarios mediante Finger (puerto 79)
  - Creacion de lista de usuarios y passwd "inteligente"
  - Checkea usuario anonimos por ftp
  - Fuerza Bruta por ftp
  - Fuerza Bruta por POP3
  - Checkea algunos cgi's
  - Wu-scan 
  - Opcion para guardar los logs
													  
.I Leer readme para ver nuevas opciones, bugs, etc

.SH OPTIONS

.I --------------------------------------------------------------------	
 n : Subnet Scan
 s : Scan de puertos utilizando la tecnica SYN (half-open connection)
 e : Usuarios mediante expn (Necesita -o userlist)
 y : Usuarios mediante vrfy (Necesita -o userlist)
 k : Usuarios mediante finger (necesita -o userlist)
 i : Creacion "inteligente" de userlist y passwordlist
 f : Fuerza bruta por ftp (requiere userlist password)
 t : Fuerza bruta por pop3(requiere userlist y passwordlist)
 p : Desacativar Ping hosts 
 a : Checkea accesso anonimo por ftp
 o : userlist and/or passwordlist 
 l : Log file
 d : Seleccionar el device a utilizar, si hay problemas con el scan
 w : Wu-ftp Scan
.I ---------------------------------------------------------------------

.I Port-Scanner:
 
Scaner de puertos: No necesita explicacion, lo que hace es tratar de
conectarse a un rango de puerto de la maquina, si lo logra esta
abierto, si no  esta cerrado. Detecta puertos filtrados.

.I Scan de puertos utilizando la tecnica SYN: En vez de
realizar un conexion completa solamente reliza  una parte del proceso del
llamado handshake (los 3 saludos), esta tecnica es llamada half-open
connection ya que no realiza una conexion completa.
    Atencion, necesitamo el comando IFCONFIG. Si nuetros devices
poseen nombres distintos a eth0 y ppp0, debemos modificar en blaster-espanol.c
las lineas 175 y 180. Si poseemos otro comando,  con otro nombre, modificar el 
archivo device-ip.h en el directorio include. Detecta puertos filtrados.


.I Scan Subnet: Nos permite escanear un rango de ip clase C,
por ejemplo si ponemos la "ip" 192.168.1  va a escanear desde 192.168.1.1
hasta 192.168.1.255.

.I Ping Host: Realiza un ping para ver si el host esta "vivo",si lo recibe lo 
escanea sino no. Esta opcion se puede desactivar. Si el host esta filtrando
intenta escanearloo.
Esta opcion se puede desactivar usando la opcion p.
Tambien detecta host que esten filtrando paquetes icmp e intenta escanearlos.
Advertencia: No es 100% fiable, ya que algunos host nos pueden decir que no
estan funcionando cuando en realidad lo estan, entonces deberemos usar la 
opcion p	   
			   

.I Usuarios mediante Expn o Vrfy:  Segun la version del
demonio de mail que utilice el host que queremeos scanear o la viveza del
administrador  se podra utilizar solamene expn, solamente vrfy o ambos.
                Pueden aparecer algun que otro resultado "extrano" como el
siguiente:

        User found:
                        slkls
                        root
                        aaaaaaaaaa
                        bin
                       03909309

Esto depende de dos factores:  El conocimiento o experiencia del
Administrador y/o el demonio usado en el puerto 25 (sendmail,etc).
En este caso, estaban configurados para "falsear" los usuarios y que
aparezacn como si fueran del host.
Al pasar una lista grande, si vemos que por ejemplo el user r989kjs9 se
encuentra podemos darnos cuenta de la veracidad del resultado.

.I  Creacion de user and passwords list "inteligente": 
Su "intencion" es la de crear un lista de usuarios y 
otra de passwords con los usuarios obtenidos utilizando -e o -y 
(expn or vrfy) automaticamente.
   Por cada usuario se crean 4 passwords en el archivo password:
			
			 
   1) El login al reves (polos = solop)
   2) El password 1234
   3) El password 123456789
   4) Login = Password

 Esta lista nos va a servir para realizar en ese host un ataque por
 fuerza bruta al ftp o pop3.
 Antes de iniciar el ataque recomiendo sacar los espacios que quedan
 en las listas creadas. (Cada 4 passwords, el programa deja un espacio)
		

.I Version: Nos da la version del demonio de los puertos 21,23 and 25.

.I Chekea usuario anonimo por ftp: No necesita explicacion.(supongo)


.I Fuerza Bruta por ftp: Intenta sacar passwd mediante fuerza
bruta por el demonio de ftp. Debemos indicarle una lista de usuarios y una
lista de passwd (diccionarios, nuestra lista, etc).
   La mayoria de los demonios de ftp, (segun como esten configurados),
cierran la conexion al quinto intento de accesso fallido, por lo tanto si
queremos que el scanner corte la conexion al 3 intento (en el caso de que
el ftp estuviera con esa configuracion) tendriamos que cambiar el i=5 que
aparece en bruteftp(). por i=x donde x es el numero donde que queremos que
corte y vuelva a conectar

.I Fuerza Bruta por POP3: Lo mismo que en Fuerza Bruta por ftp nada mas que
en se realiza en el servicio pop3 del host (puerto 110)

.I Chekea cgi: Verifica si hay algunos cgi que tiene fallas
reprtadas.
   Para agregar mas cgi's simplemente ejecutar y seguir las instrucciones

.I      ./addcgi

   (La mayoria de estos bugs o exploit para los cgi's los pueden encontrar
en :

                        www.ussrback.com
                        www.rootshell.com
                        www.anticode.com
                                etc..   )

.I Guardar Logs: simplemente debemos indicar el nombre del log cuando
   sea necesario y guardara todo lo realizado en ese archivo.

.I Extraer usuarios mediante finger: Extrae usuarios utilizando un  userlist 
   especificado
			      
.I Elejir Device: Sirve para decirle que "ip" tomar si tenemos problemas
 por ejemplo si queremos escanear una maquina dentro  de nuestra red y 
 tenemos problemas utilizarla y elejir eth0/eth1/etc o el que corresponda
 
.I Wu-scan: Permite decirnos si la version del ftp es wu-ftp y si es vulnerable.
 
.I Examples:


.I blaster 192.168.1.2 : Va a escanear esa ip desde el puerto 0 al 6003

.I blaster 0 900 snpla 192.168.1 : Va a escanear la subnet 192.168.1, realizando
un syn scan, desactivando la opcion ping, checkeando accesso anonimo en cada uno
y va a guardar un log.

.I blaster 0 900 lk 192.168.1.2 -o usuarios : Va a escanear el host determinado,
usuarios mediante finger y guardar el log.

.I blaster 0 3000 0 192.168.1.1 : 
Va a scanear desde el puerto "0" hasta el puerto 3000

.I blaster 0 900 span 192.168.1 : Va a realizar un SYN scan al rango de ip
192.168.1.1-255, desactivar la opcion ping y chekear acceso
anonimo si tiene el ftp abierto

.I blaster 0 900 spfn 192.168.1 -o usuarios passwords : Lo mismo que el
anterior pero va a realizar fuerza bruta por ftp.

.I blaster 0 1024 n 192.168.1 : Va a relizar un scaneo tcp del puerto 1 al 1024

.I blaster 20 26 w 192.168.1.1: 
Va a scanear desde el puerto 20 hasta el puerto 26 y decirnos que si la version
de ftp es WU-ftp y si es vulnerable o no.

.I blaster 1 30 -e 192.168.1.1 -o userlist : 
Va a escanear un rango de puertos (1 al 30),y si el puerto 25 esta abierto va 
a intentar sacar usuarios desde un archivo (userlist) Podemos utilizar y 
para que use Vrfy
.I
.I blaster 1 30 -eaf 192.168.1.1 -o userlist passwordlist : 
Lo mismo que en el ejemplo anterior, pero  va a chekear acceso 
anonimo y va a realizar fuerza bruta por ftp con los archivos 
dados (userlist passwdlist)
.I
.I blaster 21 21 -f 192.168.1.1 -o userlist passwordlist: 
Va a realizar fuerza bruta por ftp con los archivos asignado en 
userlist passwordlist
.I
.I blaster 25 25 -yi 192.168.1.1 -o userlist : 
Va a extraer usuarios mediante vrfy y crar un lista con los uses obtenidos.
.I
.I blaster 0 900 -st 192.168.1.1 -o userlist passwordlist : 
Va a realizar un SYN scan desde el puerto 0 al 900 y va a realizar 
fuerza bruta por pop3

.I Problemas Comunes
  
  Quizas tengas problemas cuando escaneamos fuera de nuestra red local, por
  seguramente tengamos un device diferente a los pre-seleccionados por Blaster,   
  por lo tanto debemos usar la opcion d , o cambiar en include/scana.h las lineas   
  #define ppp por el device para scanear host on inet, etc. y #define eth para
  local network, y compilarlo de nuevo
      

.I Proximas Versiones

	Leer el archivo Readme

.I Bugs, Recomendaciones,etc

	Encontraste algun bug en el codigo? mandame un mail, esto es
muy importante para mejorar el scanner en proximas versiones. 
	Cualquier recomendacion, critica o IDEAS mandenme un mail.
	Si queres colaborar con la programacion de la proxima versiones o
agregar alguna opcion mas,,, mandame un mail .

.I Author 
	
.SH     Nick: polos 		
.SH  	mail: thebigsnake@usa.net
.SH	www.ezkracho.com.ar/polos
        
.I Distribucion


Distribucion Oficial y ultimas versiones:

.SH                    http://freshmeat.net/projects/blaster/
		    
.SH		    www.ezkracho.com.ar/polos

	
Este programa pertence al Software Libre. Podes re-distribuirlo,
modificarlo, etc bajo los terminos de la Licencia Publica General GNU
publicada o creada por la fundacion del software libre. Version 2.
it under the terms of the GNU General Public License as published by the 

Deberias pedir permiso al Admin del hosts que quieres escanear antes de
hacerlo. 

Por razones de seguridad trata de no usar el scan con privilegios de root.

.I El autor no se hace responsable de danos, problemas, uso indebido,
etc. que pueda provocar el programa antes mencionado. (blaster scanner)       

I. GNU LICENSE

	Para saber mas sobre este tipo de licensias leer el archivo
GNU-License
